/*
This is part of ScreenVWM, which is based in part on the Litestep
shell source code.

Copyright (C) 2008 Jim Babcock
Copyright (C) 1997-2001 The LiteStep Development Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#pragma once
#include <litestep/lsapi/lsapi.h>
#include <map>
using std::map;

class RelCoord
{
public:
	RelCoord();
	RelCoord(string str);
	int get(int maxVal);
	
private:
	string val;
};

struct SWMImage
{
	~SWMImage();
	
	HBITMAP image;
	string filename;
	int width, height;
	int mode;
	RelCoord left, top, right, bottom;
};

class SWMImageManager
{
public:
	void loadImages();
	int parseMode(const char *mode);
	void parseLine(const char *buf);
	void destroyImages();
	
	/// Returns whether there were any images to draw for the given area
	bool drawImages(HDC drawContext, RECT area, string areaName);
	
private:
	map<string, vector<SWMImage*>*> imageSets;
};
